﻿# https://www.youtube.com/watch?v=5hyd7k4WZeI
init python:
    class bench_press_pointer(renpy.Displayable):
        def __init__(self):
            super(renpy.Displayable,self).__init__()
            self.image = "chance_bar_pointer"
            self.y = 0
            self.y_velocity = 40
            self.moving = True
        def render(self,width,height,st,at):
            if self.moving:
                self.y += self.y_velocity
                if self.y > 1000:
                    self.y = 0

            t = Transform(self.image)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (0, self.y))

            renpy.redraw(self, 0)
            return rv

    class bar_chance:
        def __init__(self, name, chance, color):
            self.name = name
            self.chance = chance
            self.color = color

    class chance_bar_class:
        def __init__(self, chances = None):
            self.chances = chances or []
            self.total = 100
            self.size = 990
            self.xsize = 400
            self.bar = bench_press_pointer()
            self.current = None
            self.calculate()
        def stop(self):
            if self.bar.moving:
                renpy.play("chance bar/win.ogg", "sound")
                self.bar.moving = False
                self.bar.y = clamp(3, self.bar.y + random.randint(-20,20), 995)

                count = 0
                for i in self.chances:
                    count += i.chance*self.size
                    self.current = i
                    if self.bar.y < count:
                        break
            # else:
            #     self.reset()
        def reset(self):
            self.bar.moving = True
            self.current = None
        def scramble(self):
            random.shuffle(self.chances)
        def add_chance(self, chance):
            self.chances.append(chance)
            self.calculate()
        def remove_chance(self, chance):
            try:
                self.chances.remove(chance)
            except:
                pass
            self.calculate()
        def calculate(self):
            total = 0
            for i in self.chances:
                total += i.chance
            self.total = total
            self.size = int(1000/total)
transform chance_bar_animation:
    on idle:
        ease .5 alpha 1 additive 0
    on selected_idle:
        ease .5 alpha .5 additive .5
        ease .5 alpha 1 additive 0
        repeat

screen chance_bar_screen(g):
    hbox:
        align .2,.5
        vbox:
            for i in g.chances:
                button:
                    xysize g.xsize,(g.size*i.chance)
                    background i.color
                    at chance_bar_animation
                    vbox:
                        text str(i.name)
                        # text str(i.chance)
                    action NullAction(), SelectedIf(i == g.current)
        frame:
            align .23,.5 padding 0,0 xoffset -30
            ysize 1000
            background None
            add g.bar yoffset -16
    button:
        background None
        action Function(g.stop)
    if g.current:
        timer 2 action Return(g.current.name)
    # vbox:
    #     text str(g.size)
    #     text str(g.total)
    #     # text str(g.current)
    #     text str(g.bar.y)
    #     button:
    #         text "add"
    #         action Function(g.add_chance, dice_duplicate)
    #     button:
    #         text "Remove"
    #         action Function(g.remove_chance, dice_duplicate)
    #     button:
    #         text "Scramble"
    #         action Function(g.scramble)

default my_credits = 150
screen credits_overlay:
    frame:
        background "#15012299" align 1.0,.0 yoffset 40 padding 20,20
        text "Credits $" + str(my_credits)
init python:
    config.overlay_screens.append("credits_overlay")

default dice_duplicate = bar_chance("Duplicate",20,"#2b3732")
define Eunji = Character("Eunji")
define me = Character("Me")
label chance_bar_example:
    show bg diner with dissolve
    show eunji business with dissolve
    Eunji "Welcome to the FNC palace, my name is Eunji."
    Eunji "Are you here for the Reflected AR demonstration?"
    me "Yes."
    Eunji "Have you received your credit token card?"
    me "I did."
    Eunji "Great. Do you want to try you luck on our free entrance prize?"
    me "Certainly."
    Eunji "Alright, to receive the reflections into your eyes, avoid sudden movement or looking down."
    Eunji "I apologize for the crude graphics in advance, it's a new technology and our designers haven't had time to give it a makeover."
    Eunji "The pool of prices is: A free drink, a tour of the city, a sweets basket or a small chance of 1000 credits."
    Eunji "Just say stop or press your card's trigger when you want."
    $ entrance = chance_bar_class(
        chances = [
            bar_chance("A free drink", 5, "#76428a"),
            bar_chance("A tour of the city", 5, "#ac3232"),
            bar_chance("A sweets basket", 5 ,"#306082"),
            bar_chance("$1000 credits", 1, "#37946e"),
        ]
    )
    call screen chance_bar_screen(entrance)

    if _return == "A free drink":
        Eunji "A free drink!"
        Eunji "I'll send your drink to you momentarily."
    elif _return == "A tour of the city":
        Eunji "You've won the tour."
        Eunji "The tour buss departs at 9 am tomorrow."
        Eunji "Please be here at 8:45."
    elif _return == "A sweets basket":
        Eunji "Excellent, I'll send one to your room."
    elif _return == "$1000 credits":
        Eunji "Our $1000 credits. Very lucky!"
        Eunji "Or skilled?"
        $ my_credits += 1000
        $ renpy.notify("You've received $1000 credits.")
        Eunji "Your winnings are added to your card."
    
    Eunji "Enjoy your stay at FNC palace."
    hide eunji with dissolve
    pause 2.0

define Jeong = Character("Jeong")
default jeong_flags = ["first"]
label jeong_start:
    show jeong date with dissolve
    Jeong "You're cute, you'll do."
    me "What?"
    Jeong "I've made an RR game, care to play it?"
    me "You can do that?"
    Jeong "Of course."
    Jeong "Here are the rules."
    Jeong "You pay 10 credits and get a spins on the bar I've designed."
    Jeong "Each time a prize is won, it's chance resets and the chance for the other prizes grows."
    me "What are the prices?"
    Jeong "A-Ahaaaa... You have to pay to see them."
    me "Alright."
    $ jeong_game = chance_bar_class(
        chances = [
            bar_chance("Nothing", 1, "#76428a"),
            bar_chance("$1", 1, "#ac3232"),
            bar_chance("$5", 1 ,"#306082"),
            bar_chance("$10", 1, "#37946e"),
            bar_chance("$20", 1, "#8f563b"),
        ]
    )
    $ jeong_game.xsize = 200

label jeong_loop:
    call screen chance_bar_screen(jeong_game)
    python:
        for i in jeong_game.chances:
            i.chance += 1
            if i.name == _return:
                i.chance = 1
    if _return == "Nothing":
        Jeong "You get nothing!"
    elif _return == "$1":
        $ my_credits += 1
        $ renpy.notify("You've received $1 credits.")
        Jeong "You get $1."
    elif _return == "$5":
        $ my_credits += 5
        $ renpy.notify("You've received $5 credits.")
        Jeong "You get $5."
    elif _return == "$10":
        $ my_credits += 10
        $ renpy.notify("You've received $10 credits.")
        Jeong "You get your money back."
    elif _return == "$20":
        $ my_credits += 20
        $ renpy.notify("You've received $20 credits.")
        Jeong "You've doubled your money."
    elif _return == "$30":
        $ my_credits += 30
        $ renpy.notify("You've received $30 credits.")
        Jeong "You've tripled your money."
    elif _return == "A kiss!":
        Jeong "Oh!"
        Jeong "The game is over."
        me "What about my kiss?"
        Jeong "The game is beta, has bugs."
        me "That's not fair..."
        Jeong "That's life..."
        return

    menu:
        "Alright! I'll play another round.":
            me "Alright! I'll play another round."
            Jeong "Alright, pay up!"
        "It doesn't seem fair." if "first" in jeong_flags and _return in ["Nothing", "$1", "$5"]:
            me "It doesn't seem fair."
            Jeong "It that so?"
            Jeong "Alright, I'll throw in a triple."
            $ jeong_flags.remove("first")
            $ jeong_flags.append("second")
            $ jeong_game.add_chance(bar_chance("$30", 1, "#595652"))
        "Still doesn't feel fair." if "second" in jeong_flags:
            me "Still doesn't feel fair."
            Jeong "How about a kiss."
            me "Sure!"
            $ jeong_flags.remove("second")
            $ jeong_game.add_chance(bar_chance("A kiss!", 1, "#df7126"))
        "Shuffle!":
            me "Shuffle!"
            Jeong "Alright."
            $ jeong_game.scramble()
        "I've had enough!":
            me "I think I've had enough!"
            Jeong "Alright."
            return
    
    $ my_credits -= 10
    $ renpy.notify("You've paid $10.")
    $ jeong_game.reset()
    $ jeong_game.calculate()
    jump jeong_loop


